Subject: Re: [homenet] Inconsistencies between hnetd and the DNCP/HNCP drafts

From: Markus Stenberg <[email-masked]>
Date: Thu, 2 Jul 2015 09:43:20 +0300

On 30.6.2015 15.01, Juliusz Chroboczek wrote:
> I've had two surprises trying to interoperate with hnetd.
>
> 1. nncp-06 Section 10 says that the Version is 0.  hnetd sends and
> expects a version field of 1.

Changed the default value to 1 to match the implementations.

> 2. The same section says the following about versioning:
>
>     Each node [...] MUST ignore (except for DNCP synchronization purposes)
>     any TLVs with a type greater than 32 published by nodes not also
>     publishing an HNCP-Version TLV or publishing such a TLV with
>     a different Version number.
>
> However, this is not what hnetd does -- if there is no Version TLV or
> the Version is 0, it drops the node, which causes persistent
> desynchronisation of DNCP state, which causes repeated Trickle timer
> resets, which sucks.

Fixed in the implementation (and added unit test for it too, 
test_hncp_net/hncp_version).

Cheers,

-Markus